# -*- coding: utf-8 -*-
#! /usr/bin/env python3
# Flashcards - a learning tool by William Dean Napier 2015-FEB-06
import os, random, flashcardtools








# initQ reads every other line in the .txt starting with line 1
def initQ(Question):
    SourceText = []
    Q = []
    # for UTF-8:  file = open(filename, encoding="utf8")
    with open('flashcards.txt', encoding="utf-8") as sourcefile:
        SourceText = sourcefile.readlines()
    sourcelength = len(SourceText)
    MaxRange = ((int(sourcelength)/2))
    i = 0
    for x in range(0, int(MaxRange)):
        Q.append(SourceText[i])
        i += 2
    return Q








# initA reads every other line in the .txt starting with line 2
def initA(Answer):
    SourceText = []
    A = []
    with open('flashcards.txt') as sourcefile:
        SourceText = sourcefile.readlines()
    sourcelength = len(SourceText)
    MaxRange = ((int(sourcelength)/2))
    y = 1
    for x in range(0, int(MaxRange)):
        A.append(SourceText[y])
        y += 2
    return A









def greet():
    print("****  Flashcards  ****")
    print("-a William Dean Napier game")
    print("\n")
    print("Welcome to Flashcards, a learning game")
    print("You can tailor the Q/A data to your needs.")
    print("Review the instructions.txt for more information.")
    print("\n")
    input("Press enter to continue... ")
    os.system("cls")
    return









def getnumberofquestions():
    x = 0
    x = input("How many questions do you want? : ")
    testinputflag = False
    while testinputflag == False:
        if x.isnumeric() == True:
            testinputflag = True
        else:
            testinputflag = False
            x = input("(incorrect response) How many questions do you want? : ")
    os.system("cls")
    return x









def getnumberofanswers():
    x = 0
    x = input("How many answers do you want? (valid inputs 1 ~ 10) : ")
    testinputflag = False
    while testinputflag == False:
        if x.isnumeric() == True:
            if int(x) >= 1 and int(x) <= 10:
                testinputflag = True
            else:
                testinputflag = False
                x = input("(incorrect response)How many answers do you want? (valid inputs 1 ~ 10) : ")
        else:
            testinputflag = False
            x = input("(incorrect response)How many answers do you want? (valid inputs 1 ~ 10) : ")
    os.system("cls")
    return x









def randomQ(Question):
    index = 0
    maxLength = len(Question)
    index = random.randint(0, maxLength-1)
    return index









def PrepareAnswers(Qindex, Question, Answer, NumberOfAnswers):
    ShuffledAnswerIntegers = []
    os.system("cls")
    ShuffledAnswerIntegers.append(Qindex) # ensures the right answer is in the list
    while len(ShuffledAnswerIntegers) < int(NumberOfAnswers): # four possible answers for now.
        x = random.randint(0, len(Question)-1)
        if x not in ShuffledAnswerIntegers:
            ShuffledAnswerIntegers.append(x)
    random.shuffle(ShuffledAnswerIntegers)# <--- here, shuffle the list!
    return ShuffledAnswerIntegers









def validateplayagain(playagain):
    testlength = len(playagain)
    playagaininput = False
    internalflag = False
    while internalflag == False:
        if testlength == 1:
            if playagain.isalpha() == True:
                playagain = playagain.lower()
                if playagain == "y":
                    playagaininput = True
                    internalflag = True
                if playagain == "n":
                    playagaininput = False
                    internalflag = True
                if playagain != "y" and playagain != "n":
                    internalflag = False
                    playagain = input("Incorrect response: Would you like to play again? y/n")
            else:
                internalflag = False
                playagain = input("Incorrect response: Would you like to play again? y/n")
        else:
            internalflag = False
            playagain = input("Incorrect response: Would you like to play again? y/n")
    return playagaininput









def validchoice(choice, Aindexes):
    menucount = len(Aindexes)
    validinput = False
    while validinput == False:
        if choice.isnumeric() == True:
            if int(choice) > 0 and int(choice) <= menucount:
                # this is good input
                validinput = True
            else:
                validinput = False
        else:
            validinput = False
    return validinput









def results(right, wrong, NumberOfQuestions):
    input("Press Enter to view your quiz results... ")
    os.system("cls")
    print("Here are your results:")
    print("Out of " + str(NumberOfQuestions) + " questions, you missed " + str(wrong) + ".")
    calcPercentage = (int(right)/int(NumberOfQuestions) * 100)
    print("Here is your score :   " + str(right) + "/" + str(NumberOfQuestions) + "    " + str(calcPercentage) + "%")
    print("\n")
    input("Press Enter to continue... ")
    return









def processmain(Question, Qindex, Aindexes, Answer, answercorrect):
    os.system("cls")
    useranswercorrect = False
    print("Question:")
    print(Question[Qindex])
    print("Answers:")
    j = 1
    y = 0
    indexMAX = len(Aindexes)

    for i in range(0, indexMAX):
        value = (Aindexes[y]) # represents Answer index value (preshuffled!)
        print(str(j) + "  : " + str(Answer[value])) # prints menu number + an answer
        j += 1 # for menu count
        y += 1 # to read through next shuffled Aindex
    choicevalidated = False
    while choicevalidated == False:
        choice = input("Choose an answer. : ")
        choicevalidated = flashcardtools.validchoice(choice, Aindexes)
        
    if Aindexes[int(choice)-1] == Qindex:
        # answered correctly!
        print("Good Job!")
        useranswercorrect = True
        """
        #### Debugger Section ####
        print("#### Debugger Section ####")
        print("Question[]   : " + str(Question))
        print("Answer[]     : " + str(Answer))
        print("Qindex       : " + str(Qindex))
        print("Aindexes     : " + str(Aindexes))
        print("indexMAX     : " + str(indexMAX))
        print("Aindexes[int(choice)]     : " + str(Aindexes[int(choice)]))
        print("Qindex     : " + str(Qindex))
        #### Debugger Section ####
        """
    else:
        # did not get the answer.
        print("I'm sorry, but that is not the correct answer.")
        print("The correct answer is  : " + str(Answer[Qindex]))
        useranswercorrect = False
  
        """
        #### Debugger Section ####
        print("#### Debugger Section ####")
        print("Question[]   : " + str(Question))
        print("Answer[]     : " + str(Answer))
        print("Qindex       : " + str(Qindex))
        print("Aindexes     : " + str(Aindexes))
        print("indexMAX     : " + str(indexMAX))
        print("Aindexes[int(choice)]     : " + str(Aindexes[int(choice)]))
        print("Qindex     : " + str(Qindex))
        #### Debugger Section ####
        """
    return useranswercorrect
















